package com.eneraptor.hci

class SysStateController {

	def reportService
	def hciLogicCommService
	
    def main = {
		
		List inDevices = DeviceInfo.findAllByInputDevice(true, [sort:'friendlyName', order:'asc'])
		List inDevicesData = new ArrayList()
		inDevices.each {
			Map inDeviceDataEntry = new HashMap()
			inDeviceDataEntry['friendlyName'] = it.friendlyName
			inDeviceDataEntry['icon'] = it.iconPath
			inDeviceDataEntry['loggedData'] = LoggedData.findByDeviceId(it.deviceId, [sort:'dateRecieved', order:'desc'])	
			inDevicesData << inDeviceDataEntry
		}
		
		List outDevices = DeviceInfo.findAllByOutputDevice(true, [sort:'friendlyName', order:'asc'])
		List outDevicesData = new ArrayList()
		outDevices.each {
			Map outDeviceDataEntry = new HashMap()
			outDeviceDataEntry['friendlyName'] = it.friendlyName
			outDeviceDataEntry['icon'] = it.iconPath
			outDeviceDataEntry['loggedData'] = LoggedData.findByDeviceId(it.deviceId, [sort:'dateRecieved', order:'desc'])
			outDevicesData << outDeviceDataEntry
		}
		
		[inDevicesData: inDevicesData, outDevicesData: outDevicesData]
		
	}
	
	def measure = {
		
		List inDevices = DeviceInfo.findAllByInputDevice(true, [sort:'friendlyName', order:'asc'])
		List inDevicesData = new ArrayList()
		inDevices.each {
			Map inDeviceDataEntry = new HashMap()
			inDeviceDataEntry['deviceId'] = it.deviceId
			inDeviceDataEntry['friendlyName'] = it.friendlyName
			inDeviceDataEntry['icon'] = it.iconPath
			inDeviceDataEntry['loggedData'] = LoggedData.findByDeviceId(it.deviceId, [sort:'dateRecieved', order:'desc'])
			inDevicesData << inDeviceDataEntry
		}
		
		[inDevicesData: inDevicesData]
		
    }
	
	def measureUpdate = {
		
		List devices = new ArrayList()
		
		DeviceInfo.findAllByInputDevice(true).each {
			if(params[it.deviceId] == "on")
				devices << it.deviceId
		}
		
		def output = "";
		
		if(devices.size == 0) {
			flash['errors'] = "<p>No device was selected. At least one device must be selected.</p>"
			redirect(action: 'measure')
			return false
		}
		
		output += reportService.println("Trying to update measurements manually for devices")
		devices.each {
			output += reportService.println(" - " + it)
		}
		output += reportService.println("Generating request xml")
		
		// generate request xml
		def reqXML = "<todo />"
		
		output += reportService.println("Request xml generated")
		output += reportService.println("Sending request")
		
		// send request
		Map rspXML = hciLogicCommService.getReplyToRequest(reqXML)
		
		if(rspXML['status'] == "error") {
			output += reportService.println("<span style='color:red;'>Error: " + rspXML['content'] + "</span>")
		} else {
			output += reportService.println("<span style='color:red;'>Error: implementation missing - TODO.</span>")
		}
		
		[errorExplanation: output]
		
	}
	
	def actions = {
		
		List outDevices = DeviceInfo.findAllByOutputDevice(true, [sort:'friendlyName', order:'asc'])
		List outDevicesData = new ArrayList()
		outDevices.each {
			Map outDeviceDataEntry = new HashMap()
			outDeviceDataEntry['deviceId'] = it.deviceId
			outDeviceDataEntry['friendlyName'] = it.friendlyName
			outDeviceDataEntry['icon'] = it.iconPath
			outDeviceDataEntry['loggedData'] = LoggedData.findByDeviceId(it.deviceId, [sort:'dateRecieved', order:'desc'])
			outDevicesData << outDeviceDataEntry
		}
		
		[outDevicesData: outDevicesData]
		
    }
	
}
